'use strict';

const net = require('net');
const loginRequestPacket = Buffer.from('ESP calling\r');
const loginResponsePacket = Buffer.from('Welcome ESP01!');
const keepAlivePacket = Buffer.from('bim');

const MESSAGE_PACKET = 'm'.charCodeAt(0);
const DATA_PACKET = 'd'.charCodeAt(0);

var program_connected = 0;

const mysql = require('mysql');

var con = mysql.createConnection({
  host: "host", //
  user: "user", //
  password: "heslo", //
  database: "database" // nahradit za realne hodnoty
});

con.connect(function(err) {
  if (err) throw err;
  console.log("Connected!");
  con.query("SELECT * FROM park_sensor", function (err, result) {
    if (err) throw err;
    result.forEach( (row) => {
      console.log(`${row.id} : ${row.date_time} : ${row.temp} : ${row.hum}`);
    });
  });
});

function addRecord(temperature, humidity)
{
  con.query("INSERT INTO park_sensor (temp,hum) VALUES (" + temperature + ", " + humidity + ")",
    function (err, result) {
     if (err) throw err; });

  console.log("added record (" + temperature + ", " + humidity + ")");
}

function processPacket(packet, socket)
{
  if (packet.compare(loginRequestPacket) == 0)
  {
    program_connected = 1;
    sendPacket(socket, loginResponsePacket);
    console.log("program connected");
  }
  else if (packet[0] == MESSAGE_PACKET)
  {
    var msg = packet.slice(2);
    console.log("msg " + msg);
  }
  else if (packet[0] == DATA_PACKET)
  {
    var data = packet.toString().split(" ");
    console.log("data " + data);
    addRecord(data[1], data[2]);
  }
  else console.log("unrecognized packet " + packet);
}

function sendPacket(socket, packet)
{
  if (!program_connected)
  {
      console.log("program not connected, will not send packet");
      return;
  }
  socket.write(packet);
}

function keepAlive(socket)
{
  sendPacket(socket, keepAlivePacket);
}

var program_socket;
var connection = net.createServer((socket) => {

        console.log("connection detected");
        program_socket = socket;
        socket.setNoDelay(true);
        var bytesOfPacketRead = 0;
        var pinger;
        socket.on('data', (data) => {
                        console.log("data");
                        processPacket(data, socket);
        });

        socket.on('close', (data) => {
        console.log('closed connection');
        program_connected = 0; });

        socket.on('end', (data) => {
        console.log('program disconnects');
        program_connected = 0; });

        socket.on('error', (data) => { console.log('error on socket'); });
        pinger = setInterval(function() {
        if (program_connected) keepAlive(socket);
        else clearInterval(pinger); }, 60000);
});

connection.listen(9933);
connection.on('listening', () => {
console.log('listnening...')
});